<?php

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
*
* @version $Id: ps_certitrade.php 617 2007-01-04 19:43:08Z  $
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2007 ct. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*/

/**
* The ps_twocheckout class for transactions with 2Checkout 
 */
class ps_certitrade {

    var $payment_code = "CERTI";
    var $classname = "ps_certitrade";
  
    /**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
    function show_configuration() { 
    
      define('CERTI_MD5_TEXT','Din MD5-nyckel som du har fått av CertiTrade. Du behöver bara fylla i din md5-nyckel för att kunna använda det skarpa systemet. I testläget används en fördefinierad MD5-nyckel.');
      define('CERTI_VERIFIED_STATUS_TEXT','Välj den orderstatus till vilken aktuell order blir uppdaterad till om betalningen lyckas. Om nedladdningsoptioner används se till att välja den orderstatus som gör nedladdning möjlig.');
      define('CERTI_INVALID_STATUS_TEXT','Välj en orderstatus för betalningsförsök som nekas.');
      define('CERTI_TESTMODE_TEXT','Välj "Yes" för testläge för att prova CertiTrade kortbetalning.');
      
      global $VM_LANG;
      $database = new ps_DB();
      /** Read current Configuration ***/
      require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
       $img_src_catalog_fixed_path = "../".CERTI_IMG_SRC_PATH;
    ?>
      <table class="adminform">
        <tr class="row0">
            <td><strong>Sökväg till bildfil</strong></td>
            <td>
                <input type="text" name="CERTI_IMG_SRC_PATH" class="inputbox" size="70" value="<?php echo CERTI_IMG_SRC_PATH ?>" />
            </td>
            <td>Ange filens namn inkl sökväg(Spara minst en gång för att uppdatera databasen med sökvägen till filen)
            </td>
        </tr>
        <tr>
            <td><strong>Bild vid betalval</strong></td>
            <td>
                <img src="<?php echo $img_src_catalog_fixed_path?>" >
            </td>
            <td>Bilden(om någon) letas upp som om nuvarande folder är joomlarooten.
            </td>
        </tr>
        <tr>
            <td><strong>Merchant ID</strong></td>
            <td>
                <input type="text" name="CERTI_MID" class="inputbox" value="<?php echo CERTI_MID ?>" />
            </td>
            <td>Ditt "merchant id" (kundnummer)som du erhållit av CertiTrade (Du kan testa med ditt kundnummer eller ett öppet kundnummer som är 1111)
            </td>
        </tr>
        <tr>
            <td><strong>MD5 nyckel</strong></td>
            <td>
                <input type="text" name="CERTI_MD5" class="inputbox" value="<?php echo CERTI_MD5 ?>" />
            </td>
            <td><?php echo CERTI_MD5_TEXT ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_PAYMENT_ORDERSTATUS_SUCC') ?></strong></td>
            <td>
                <select name="CERTI_VERIFIED_STATUS" class="inputbox" >
                <?php
                    $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
                    $database->query($q);
                    $rows = $database->record;
                    $order_status_code = Array();
                    $order_status_name = Array();
                    
                    foreach( $rows as $row ) {
                      $order_status_code[] = $row->order_status_code;
                      $order_status_name[] =  $row->order_status_name;
                    }
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (CERTI_VERIFIED_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td><?php echo CERTI_VERIFIED_STATUS_TEXT ?>
            </td>
        </tr>
            <tr>
            <td><strong><?php echo  $VM_LANG->_('PHPSHOP_ADMIN_CFG_PAYMENT_ORDERSTATUS_FAIL') ?></strong></td>
            <td>
                <select name="CERTI_INVALID_STATUS" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (CERTI_INVALID_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td><?php echo CERTI_INVALID_STATUS_TEXT ?>
            </td>
        </tr>
        <tr>
            <td><strong>Manuell capture</strong></td>
            <td>
                <select name="CERTI_DELAYED_CAPTURE" class="inputbox" >
                  <option <?php if (CERTI_DELAYED_CAPTURE == 'True') echo "selected=\"selected\""; ?> value="True"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
                  <option <?php if (CERTI_DELAYED_CAPTURE == 'False') echo "selected=\"selected\""; ?> value="False"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
            <td>Vid manuell capture sker endast reservation av belopp på kundens kort och du måste själv regelbundet hantera (godkänna för capture eller återbetala(i detta fall ta bort reservationen på; kundens kort) transaktionerna. (Om du väljer "No" här så sker capture med automatik.)
            </td>
        </tr>
        <tr>
            <td><strong>Testläge</strong></td>
            <td>
                <select name="CERTI_TESTMODE" class="inputbox" >
                  <option <?php if (CERTI_TESTMODE == 'Y') echo "selected=\"selected\""; ?> value="Y"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
                  <option <?php if (CERTI_TESTMODE == 'N') echo "selected=\"selected\""; ?> value="N"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
            <td><?php echo CERTI_TESTMODE_TEXT ?>
            </td>
        </tr>
      </table>
   <?php
      // return false if there's no configuration
      return true;
   }
   
    function has_configuration() {
      // return false if there's no configuration
      return true;
   }
   
  /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_writeable() {
      return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
   
  /**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_readable() {
      return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }  
   
   /**
	* Create table paytrans if not exist
	* @param -
	* @returns boolean True when writing was successful
	*/
     
   function db_paytrans(&$d){
     $query = "CREATE TABLE IF NOT EXISTS `jos_vm_paytrans` (
  `paytrans_id` int(11) unsigned NOT NULL auto_increment,
  `payment_processor` varchar(40) NOT NULL default '',
  `cart_id_number` varchar(40) NOT NULL default '',
  `customers_id` varchar(40) NOT NULL,
  `trans_order_id` varchar(40) default NULL,
  `orders_id` int(11) default NULL,
  `amount` decimal(15,4) default NULL,
  `currency` char(3) default NULL,
  `result` char(8) default NULL,
  `result_code` tinytext,
  `bank_code` tinytext,
  `trnumber` tinytext,
  `authcode` tinytext,
  `pay_result` tinytext,
  `pay_counter` int(11) default '0',
  `cc_descr` tinytext,
  `created` varchar(30) default NULL,
  `completed` varchar(30) default NULL,
  `temp_data` mediumtext,
  PRIMARY KEY  (`paytrans_id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1";
	 $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	 
	 
	 $dbj = JFactory::getDBO(); 
	 $q = 'select payment_extrainfo from #__vm_payment_method where payment_class = "ps_certitrade" limit 0,1'; 
	 $dbj->setQuery($q); 
	 $res = $dbj->loadResult(); 
	 
	 $e = $dbj->getErrorMsg(); 
	 if (!empty($e))
	 var_dump($e); 
	  
	 if (empty($res))
	 {
	  $x = file_get_contents(JPATH_SITE.DS.'components'.DS.'com_virtuemart'.DS.'themes'.DS.'default'.DS.'templates'.DS.'onepage'.DS.'overrides'.DS.'ps_certitrade'.DS.'checkout.thankyou.tpl.php'); 
	  $d['payment_extrainfo'] = $x; 
	  /*
	  $q = "update #__vm_payment_method set `payment_extrainfo` = '".$dbj->getEscaped($x)."' where payment_class='ps_certitrade'  limit 1"; 
	  $dbj->setQuery($q); 
	  $dbj->query(); 
	  
	  $e = $dbj->getErrorMsg(); 
	  if (!empty($e))
	  var_dump($e); 
	  //die(); 
	  */
	 }
	 
	 
	return true; 	
   }
  

/**
	* Alter table orders so that order_id is long enough for VirtueMart 1.1
	* @param -
	* @returns boolean True when writing was successful
	*/
     
   function db_orders(){
	 $query = "ALTER TABLE `jos_vm_orders` MODIFY `order_number` varchar(40) NULL";
	 
	 
	 $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	return true; 
   }
  
  /**
	* Add a column for filename of picture if not exsist
	* @param -
	* @returns boolean True when writing was successful
	*/
     
   function db_paymentmethod(){
     
     $exists = false;
     $query = "show columns from jos_vm_payment_method";
     
     $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	 
     while ($dbst->next_record() && !$exists) {
     	if ($dbst->f("Field") == 'payment_method_img_src') {
            $exists = true;
        }
     }      
     if(!$exists){
        $query="ALTER TABLE `jos_vm_payment_method` ADD (`payment_method_img_src` varchar(64) default NULL)  ";
        $dbst->setQuery($query);
	    $dbst->query();
     }	  
    }
    
    
    /**
	* Add a column for remainder_amount in ...._orders if not exsist
	* @param -
	* @returns boolean True when writing was successful
	*/
     
   function db_ordersAmountReminder(){
     
     $exists = false;
     $query = "show columns from jos_vm_orders";
     
     $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	 
     while ($dbst->next_record() && !$exists) {
     	if ($dbst->f("Field") == 'remainder_amount') {
            $exists = true;
        }
     }      
     if(!$exists){
        $query="ALTER TABLE `jos_vm_orders` ADD (`remainder_amount` decimal(15,5) default '0.00000')  ";
        $dbst->setQuery($query);
	    $dbst->query();
     }	  
    }

   /**
	* Add a column for faktura_pnr in ...._order_user_info if not exsist
	* @param -
	* @returns boolean True when writing was successful
	*/
   function db_orderuserinfoPnr(){
	 $exists = false;
     $query = "show columns from jos_vm_order_user_info";
     
     $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	 
     while ($dbst->next_record() && !$exists) {
     	if ($dbst->f("Field") == 'faktura_person_nr') {
            $exists = true;
        }
     }      
     if(!$exists){          
        $query="ALTER TABLE `jos_vm_order_user_info` ADD (`faktura_person_nr` varchar(16) default NULL)  ";
        $dbst->setQuery($query);
	    $dbst->query();
     }	  
   }
   
  
   /**
	* Updates orderstatus table with more data if needed
	* @param -
	* @returns boolean True when writing was successful
	*/
   function db_updateOrderStatus(){
  
    $dboi = new ps_DB;
    $r = "SELECT order_status_code FROM jos_vm_order_status WHERE order_status_code= 'I'";
	$dboi->query($r);
	if ( !$dboi->next_record() ){
       $query1 = "insert into `jos_vm_order_status` (`order_status_id`,`order_status_code`,`order_status_name`,`order_status_description`,`list_order`,`vendor_id`) values (6,'I','Partly payed','',6,1)";
       $dboi->query($query1);
    }
    
    $r = "SELECT order_status_code FROM jos_vm_order_status WHERE order_status_code= 'W'";
	$dboi->query($r);
	if ( !$dboi->next_record() ){
      $query2 = "insert into `jos_vm_order_status` (`order_status_id`,`order_status_code`,`order_status_name`,`order_status_description`,`list_order`,`vendor_id`) values (7,'W','Waiting for final payment','',7,1)";
      $dboi->query($query2);
    }
    
    $r = "SELECT order_status_code FROM jos_vm_order_status WHERE order_status_code= 'F'";
	$dboi->query($r);
	if ( !$dboi->next_record() ){
      $query3 = "insert into `jos_vm_order_status` (`order_status_id`,`order_status_code`,`order_status_name`,`order_status_description`,`list_order`,`vendor_id`) values (8,'F','Fakturerad','',8,1)";
      $dboi->query($query3);
    }
  }
  
  

  /**
	* Writes filename of picture to table payment_method for this particular row
	* @param -
	* @returns boolean True when writing was successful
	*/
  
   function db_paymentmethod_setimgsrc( $img_src_path ){
	 $query = "UPDATE jos_vm_payment_method SET payment_method_img_src='".$img_src_path."' WHERE payment_class='".$this->classname."'";
     
     $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
   }
    
   function db_userfield(){ 
   	
   	 $query= "SELECT * FROM jos_vm_userfield WHERE name='delimiter_faktura' ";
   	 $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	 if ($dbst->num_rows() == 0){
		$query = "insert into `jos_vm_userfield` (`name`,`title`,`description`,`type`,`maxlength`,`size`,`required`,`ordering`,`cols`,`rows`,`value`,`default`,`published`,`registration`,`shipping`,`account`,`readonly`,`calculated`,`sys`,`vendor_id`,`params`) values ('delimiter_faktura','PHPSHOP_ACCOUNT_FAKTURA_TITLE','','delimiter',25,30,0,36,NULL,NULL,NULL,NULL,1,0,0,1,0,0,0,1,NULL)";
		$dbst->setQuery($query);
	    $dbst->query();
	 }
   	
     $query= "SELECT * FROM jos_vm_userfield WHERE name='faktura_person_nr' ";
     
	 $dbst->setQuery($query);
	 $dbst->query();
	 if ($dbst->num_rows() == 0){
		$query="insert into `jos_vm_userfield` (`name`,`title`,`description`,`type`,`maxlength`,`size`,`required`,`ordering`,`cols`,`rows`,`value`,`default`,`published`,`registration`,`shipping`,`account`,`readonly`,`calculated`,`sys`,`vendor_id`,`params`) values ('faktura_person_nr','PHPSHOP_ACCOUNT_LBL_FAKTURA_PERSON_NR','','text',12,12,0,37,NULL,NULL,NULL,NULL,1,0,0,1,0,0,1,1,NULL)";
		$dbst->setQuery($query);
	    $dbst->query();
	 }
	 
   }// end function db_userfield
   
   function db_user_info(){
     
	 $exists = false;
     $query = "show columns from jos_vm_user_info";
     
     $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	 
     while ($dbst->next_record() && !$exists) {
     	if ($dbst->f("Field") == 'faktura_person_nr') {
            $exists = true;
        }
     }      
     if(!$exists){
        $query="ALTER TABLE `jos_vm_user_info` ADD (`faktura_person_nr` varchar(12) default NULL )   ";
        $dbst->setQuery($query);
	    $dbst->query();
     }	  	
	
   } // end function db_userinfo
   
    
   function db_invoices(){
	   $query = "CREATE TABLE IF NOT EXISTS `jos_vm_invoices` (
         `invoices_id` int(11) unsigned NOT NULL auto_increment,
         `payment_processor` varchar(40) default 'EFFAKTURA',
         `customers_id` varchar(40) default NULL,
         `file_name` varchar(64) default NULL,
         `state` int(11) default '1',
         `amount` decimal(15,4) default NULL,
         `currency` char(3) default 'SEK',
         `created` varchar(30) default NULL,
         `completed` varchar(30) default NULL,
         PRIMARY KEY  (`invoices_id`)
         ) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1";
	 $dbst = new ps_DB;
	 $dbst->setQuery($query);
	 $dbst->query();
	return true; 
   } //end function db_invoices
    
  /**
	* Writes the configuration file for this payment method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
   function write_configuration( &$d ) {
   	//first some databases stuff
   	  $this->db_paytrans($d);
   	  $this->db_orders();
   	  $this->db_paymentmethod();
   	  $this->db_ordersAmountReminder();
   	  $this->db_orderuserinfoPnr();
   	  $this->db_updateOrderStatus();
   	  $this->db_userfield();
   	  $this->db_user_info();
   	

   	  $this->db_invoices();
   	  //then data to db
   	  $this->db_paymentmethod_setimgsrc( $d['CERTI_IMG_SRC_PATH'] );
   	  //OK, ready

      
      $my_config_array = array("CERTI_MID" => $d['CERTI_MID'],
                                "CERTI_MD5" => $d['CERTI_MD5'],
                                "CERTI_VERIFIED_STATUS" => $d['CERTI_VERIFIED_STATUS'],
                                "CERTI_INVALID_STATUS" => $d['CERTI_INVALID_STATUS'],
                                "CERTI_TESTMODE" => $d['CERTI_TESTMODE'],
                               "CERTI_DELAYED_CAPTURE" => $d['CERTI_DELAYED_CAPTURE'],
                               "CERTI_IMG_SRC_PATH" => $d['CERTI_IMG_SRC_PATH']
                          );
      $config = "<?php\n";
      $config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
      foreach( $my_config_array as $key => $value ) {
        $config .= "define ('$key', '$value');\n";
      }
      
      $config .= "?>";
  
      if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
          fputs($fp, $config, strlen($config));
          fclose ($fp);
          return true;
     }
     else
        return false;
   }
   
   function redirect()
   {
      	static $alreadyRun; 
   	 // echo $_REQUEST['shipping_rate_id']; exit;
   	
      //if ( !isset($d['order_status']) )
	  if (empty($alreadyRun))
	  {
	  $alreadyRun = true; 
      	   // prevent second call tp ps_checkout::add() to pick another order_number
      	   $d['order_number'] = $order_number;
   	       $d_commasep = "";	
   	       foreach ($d as $key => $value) {
              //echo "Parameter: $key; Value: $value<br />\n";
              $d_commasep .= $key ."," . $value .";";
           }	
   	      $now=date("Y-m-d H:i:s");
   	      $q2  = "INSERT INTO #__vm_paytrans SET payment_processor='CERTITRADE' " .
			     ", customers_id   = '".$d['ship_to_info_id']."'" .
				 ", trans_order_id = '".$order_number."'" .
				 ", amount         = '".$order_total."'" .
				 ", currency       = '".$_SESSION['vendor_currency']."'" .
				 ", created        = '".$now."'".
				 ", temp_data      = '".$d_commasep."'";
				  
	      $dbst = new ps_DB;
	      $dbst->setQuery($q2);
	      $dbst->query();
	      //----------------------------------------------	
		  $h = "Location: " . SECUREURL . "certitrade_post.php?ordernumber=". $order_number . "&userinfoid=" . $d['ship_to_info_id'] ."&vendor_currency=". $_SESSION['vendor_currency'] ."&ordertotal=" .$order_total ;
		  
		  
		  header($h); 
	      
		  $app = JFactory::getApplication(); 
		  $app->close(); 
		  
	   } else {
   	      require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
   	      // kolla betstatus
   	      //return true om ok annars return false
          if ($d['order_status'] == CERTI_VERIFIED_STATUS)  {
             return true;
            //order payed
          } else { 
			return false;
			//order not payed
		  } // end if betalt
		} // end if


   }
   
  /**************************************************************************
  ** name: process_payment()
  ** created by: soeren
  ** description: 
  ** parameters: $order_number, the number of the order, we're processing here
  **            $order_total, the total $ of the order
  ** returns: 
  ***************************************************************************/
   function process_payment($order_number, $order_total, &$d) {
     return true; 
   }
   	
   
   
   
}
