<?php 
/**
*
* CertiTrade Order Confirmation Handler
*
* @version $Id: checkout.certitrade.php 617 2007-01-04 19:43:08Z soeren_nb $
* @package VirtueMart
* @subpackage html
* @copyright Copyright (C) 2007 Ct. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*/
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );    

/**
* Read the post from 2Checkout system 
* I have used $_REQUEST instead of $_POST, because
* the "direct return" feature comes here using the GET method
* and $_REQUEST includes $_POST as well as $_GET
**/
if( !isset( $_REQUEST["orderid"] ) || empty( $_REQUEST["orderid"] ))
  echo "Order ID is not set or emtpy!";
else {
  
  define ('CERTI_SUCCESSFUL_PAYMENT_COMMENT1', 'Transaktionen har godkänts av CertiTrade kortbetalning'); 
define ('CERTI_SUCCESSFUL_PAYMENT_COMMENT2',' med Tr-nummer: ');
define ('CERTI_SUCCESSFUL_PAYMENT_COMMENT3',' och Auktorisationskod: '); 

define ('CERTI_LOCAL_CANCEL','Köp avbrutet, varukorgen är sparad.');
  
  /* Load the CertiTrade Configuration File */ 
  require_once( CLASSPATH. 'payment/ps_certitrade.cfg.php' );
  
  /* collect some variables */
  $merchantid  =  $_REQUEST["merchantid"] ;
  $orderid     =  $_REQUEST["orderid"] ; 
  $amount      =  $_REQUEST["amount"] ;
  $currency    =  $_REQUEST["currency"] ;
  $result      =  $_REQUEST["result"] ;
  $result_code =  $_REQUEST["result_code"] ;
  $bank_code   =  $_REQUEST["bank_code"] ;
  $trnumber    =  $_REQUEST["trnumber"] ;
  $authcode    =  $_REQUEST["authcode"] ;
  $lang        =  $_REQUEST["lang"] ;
  $ch_name     =  $_REQUEST["ch_name"] ;
  $ch_address1 =  $_REQUEST["ch_address1"] ;
  $ch_address2 =  $_REQUEST["ch_address2"] ;
  $ch_address3 =  $_REQUEST["ch_address3"] ;
  $ch_zip      =  $_REQUEST["ch_zip"] ;
  $ch_city     =  $_REQUEST["ch_city"] ;
  $ch_phone    =  $_REQUEST["ch_phone"] ;
  $ch_email    =  $_REQUEST["ch_email"] ;

  
  // In Demo Mode the MD5 Hash is AAAA...
  if ( CERTI_TESTMODE == 'Y'){
	$md5key = "AAAABBBBCCCCDDDDEEEEFFFFGGGGHHHH";
  } else {
    $md5key = CERTI_MD5;
  }

  /* Concat some variables for MD5 Hashing (like 2Checkout does online)
  * order_number is the 2Checkout Order Number, not our one!
  */
  $compare_string = $md5key;
  $compare_string .= $merchantid;
  $compare_string .= $orderid;    
  $compare_string .= $amount;     
  $compare_string .= $currency;
  $compare_string .= $result;    
  $compare_string .= $result_code;
  $compare_string .= $bank_code;   
  $compare_string .= $trnumber;    
  $compare_string .= $authcode;   
  $compare_string .= $lang;       
  $compare_string .= $ch_name;  
  $compare_string .= $ch_address1;
  $compare_string .= $ch_address2; 
  $compare_string .= $ch_address3; 
  $compare_string .= $ch_zip;   
  $compare_string .= $ch_city;     
  $compare_string .= $ch_phone;    
  $compare_string .= $ch_email;  
  
  // make it md5
  $compare_hash1 = md5($compare_string);
  $compare_hash2 = $_REQUEST['md5code'];
  $imageurl = 'components/com_virtuemart/shop_image/ps_image/epay_images/';
  
  /* If both hashes are the same, the post should come from 2Checkout */
  if ($compare_hash1 != $compare_hash2) {
        ?>
        <img src="<?php echo $imageurl ?>button_cancel.png" align="center" alt="<?php echo $VM_LANG->_('VM_CHECKOUT_FAILURE'); ?>" border="0" />
        <span class="message"><?php echo $VM_LANG->_('PHPSHOP_PAYMENT_ERROR') ?></span><?php
  }
  else {
  	    
        $order_number = $orderid;
        //---------Restore $d ------------------
        $qv = "SELECT trans_order_id, temp_data FROM #__{vm}_paytrans ";
        $qv .= "WHERE trans_order_id='".$order_number."'";
        $dbbt = new ps_DB;
        $dbbt->query($qv);
        $dbbt->next_record();
        $d_commasep  = $dbbt->f("temp_data");
        //fixa d igen
        $d_rows = split("[;]" , $d_commasep);
        
        for ($j=0; $j<sizeof($d_rows); $j++ ){
          $d_onerow = split("[,]" , $d_rows[$j]);
          
          $key   = (string)$d_onerow[0];
		  if (isset($d_onerow[1]))
          $value = (string)$d_onerow[1];
		  else $value=''; 
          
          $key=str_replace(',','',$key);
          $key=str_replace(' ','',$key);
          $key = rtrim($key);
          $key = ltrim($key);
          
          $value=str_replace(';','',$value);
          $value=str_replace('\r','',$value);
          $value=str_replace('\n','',$value);
          if ($key != ""){
            $d["$key"] = $value;
          }
        
        }  

			$q = "SELECT order_id FROM #__vm_orders WHERE order_number = ";
		    $q .= "'" . $order_number . "'";
		    $db = new ps_DB;
		    $db->query($q);
		    $db->next_record();
		    $order_id = $db->f("order_id");
			$d['order_id'] = $order_id; 
			$d['order_status'] = $db->f('order_status'); 
			$d['ship_to_info_id'] = $db->f('user_info_id'); 
			
        //--------------------------------------
        if ( ($result_code == '00' ) AND ($d['order_status'] != CERTI_VERIFIED_STATUS) ) {
            
            // UPDATE THE ORDER STATUS to 'VALID'
            $d['order_status'] = CERTI_VERIFIED_STATUS;
             // Setting this to "Y" = yes is required by Danish Law for wexample
            $d['notify_customer'] = "N";
            $d['include_comment'] = "Y";
            // Notifying the customer about the transaction nr and authcode
            // the order Status Update
            $d['order_comment'] = CERTI_SUCCESSFUL_PAYMENT_COMMENT1 ."\n". CERTI_SUCCESSFUL_PAYMENT_COMMENT2 . $trnumber. CERTI_SUCCESSFUL_PAYMENT_COMMENT3 .$authcode;
            $d['customer_note'] = $d['order_comment'];
            
            //---------------- fix and trix-------------------------------
            $_REQUEST['ship_to_info_id'] = $d['ship_to_info_id'];
            
            //require_once ( CLASSPATH . 'ps_checkout.php' );
            //$ps_checkout = new ps_checkout();
            // Create a Shipping Object and assign it to the _SHIPPING attribute
		    // We take the first Part of the Shipping Rate Id String
		    // which holds the Class Name of the Shipping Module
		    /*
			$rate_array = explode( "|",urldecode($d['shipping_rate_id']) );
		    
		    $filename = basename( $rate_array[0] );
		    if ($filename != ""){
		      include_once( CLASSPATH. "shipping/".$filename.".php" );
		      eval( "\$ps_checkout->_SHIPPING =& new ".$filename."();");
		    }
		    $_REQUEST['shipping_rate_id'] = $d['shipping_rate_id'];
		    
            $ps_checkout->add($d); 
			*/
			
            // -------------- get orderid and update paytrans ------------------
          
			require_once ( CLASSPATH . 'ps_order.php' );
			$ps_order= new ps_order;
			$ps_order->order_status_update($d);
			
		    //--------------------- now update paytrans------------------------
		    $q2  = "UPDATE  #__vm_paytrans SET orders_id='".$order_id."' " .
				 "WHERE trans_order_id='".$order_number."' ";	  
	        $dbst = new ps_DB;
	        $dbst->setQuery($q2);
	        $dbst->query();      
	        //---------------------klart, plocka ut kundens angivna mailadr--------------------
            $q3 = "SELECT user_email FROM #__vm_order_user_info WHERE order_id = '".$order_id."'";
            //stringDump($q3);
		    $db3 = new ps_DB;
		    $db3->query($q3);
		    $db3->next_record();
		    $ch_email = $db3->f("user_email");
            //---------------------klart ---------------------------------------
    ?> 
            <h3><?php echo $VM_LANG->_('PHPSHOP_THANKYOU') ?></h3>
            <img src="<?php echo $imageurl ?>button_ok.png" align="center" alt="Success" border="0" />
            <h2><?php echo $VM_LANG->_('PHPSHOP_PAYMENT_TRANSACTION_SUCCESS') ?></h2>
            <p><?php echo CERTI_SUCCESSFUL_PAYMENT_COMMENT1 ."<br>". "TRnummer: " .$trnumber . "<br>Auktorisationskod: " . $authcode?></p>
            
  <?php echo $VM_LANG->_('PHPSHOP_EMAIL_SENDTO') .": <strong>". $ch_email; ?></strong><br />
            <br />
<p><a href="<?php @$sess->purl( SECUREURL."index.php?option=com_virtuemart&page=account.order_details&order_id=".$d['order_id'] ) ?>">
   <?php echo $VM_LANG->_('PHPSHOP_ORDER_LINK') ?></a>
</p>
        <?php
        
        }
        else {
            // the Payment wasn't successful. Maybe the Payment couldn't
            // be verified and is pending
            // UPDATE THE ORDER STATUS to 'INVALID'
            $d['order_status'] = CERTI_INVALID_STATUS;
            
    ?> 
            <img src="<?php echo $imageurl ?>button_cancel.png" align="center" alt="Cancel" border="0" />
            <h2><?php echo CERTI_LOCAL_CANCEL ?></h2>
        <?php
        } 
  }
  
}
?> 

